#Include "PROTHEUS.CH"

User Function TranM2()

Private aRotina := {}
Private cCadastro := "Transaes"

AAdd(aRotina, {"Pesquisar" , "AxPesqui"  , 0, 1})
AAdd(aRotina, {"Visualizar", "u_TM2Manut", 0, 2})
AAdd(aRotina, {"Incluir"   , "u_TM2Manut", 0, 3})
AAdd(aRotina, {"Alterar"   , "u_TM2Manut", 0, 4})
AAdd(aRotina, {"Excluir"   , "u_TM2Manut", 0, 5})

dbSelectArea("SZ2")
dbOrderNickName("NR_IT")
dbGoTop()

mBrowse(,,,,"SZ2")

Return Nil

//----------------------------------------------------------------------------------------------------------------//
User Function TM2Manut(cAlias, nReg, nOpc)

Local oDlg
Local oFont
Local nLin
Local nTop
Local nLeft
Local nBottom
Local nRight
Local cLinhaOK
Local cTudoOK
Local cIniCpos
Local lDelete
Local nMax
Local cFieldOK
Local cSuperDel
Local cDelOK
Local nCol
Local nCampo

Local oEnchoice
Local oGetDados
Local aAlt := {}

Private aHeader := {}                       // Cabecalho das colunas da GetDados.
Private aCols   := {}                       // Colunas da GetDados.
Private oSayTotalD
Private oSayTotalS

////////////////////////////////////////////////////////////////////////////////////////////////////
// Cria variaveis de memoria:                                                                     //
// Para cada campo da tabela, cria uma variavel de memoria com o mesmo nome.                      //
// Estas variaveis sao usadas em validacoes e gatilhos que existirem para este arquivo.           //
////////////////////////////////////////////////////////////////////////////////////////////////////
/* Campos do SZ2:
  ,-----------,----------,------,-------------------------------,
  |   Campo   |   Tipo   | Tam. |     Inicializador padrao      |
  |-----------|----------|------|-------------------------------|
1 | Z2_Filial | Caracter |   2  |                               |
2 | Z2_Nome   | Caracter |  20  |                               |
3 | Z2_Numero | Caracter |   4  | GetSXENum(SZ2, Z2_NUMERO) |
4 | Z2_Item   | Caracter |   2  |                               |
5 | Z2_Data   | Data     |   8  | dDataBase                     |
6 | Z2_Tipo   | Caracter |   1  | 1                           |
7 | Z2_Hist   | Caracter |  20  |                               |
8 | Z2_Valor  | Numerico | 12,2 |                               |
9 | Z2_Aprov  | Caracter |   3  |                               |
  '-----------'----------'------'-------------------------------'*/

dbSelectArea(cAlias)

For nCampo := 1 To FCount()       // nCampo -->      1           2           3      ...     9

    cCampo := FieldName(nCampo)   // cCampo --> "Z2_FILIAL"  "Z2_NOME"  "Z2_NUMERO" ... "Z2_APROV"
    M->&(cCampo) := CriaVar(cCampo, .T.)

 // M->&("Z2_NOME")   := CriaVar("Z2_NOME"  , .T.)    ---,
 //                                                      |
 // M->Z2_NOME        := "                    "       <--'

Next

/* Variaveis criadas e seus conteudos:

   M->Z2_FILIAL   "  "
   M->Z2_NOME     "                    "
   M->Z2_NUMERO   "NNNN"   --> ultimo num.+1
   M->Z2_ITEM     "  "
   M->Z2_DATA     99/99/99 --> data-base do sistema
   M->Z2_TIPO     "1"
   M->Z2_HIST     "                    "
   M->Z2_VALOR    0.00
   M->Z2_APROV    "   "
*/

////////////////////////////////////////////////////////////////////////////////////////////////////
// Cria vetor aHeader.                                                                            //
////////////////////////////////////////////////////////////////////////////////////////////////////

dbSelectArea("SX3")
dbSetOrder(1)
dbSeek(cAlias)

While SX3->X3_Arquivo == cAlias .And. !SX3->(EOF())

   If X3Uso(SX3->X3_Usado)    .And.;                            // O Campo  usado.
      cNivel >= SX3->X3_Nivel .And.;                            // Nivel do Usuario >= Nivel do Campo.
      Trim(SX3->X3_Campo) $ "Z2_ITEM/Z2_TIPO/Z2_HIST/Z2_VALOR"  // Campos que ficarao na GetDados.

      AAdd(aHeader, {Trim(SX3->X3_Titulo),;
                     SX3->X3_Campo       ,;
                     SX3->X3_Picture     ,;
                     SX3->X3_Tamanho     ,;
                     SX3->X3_Decimal     ,;
                     SX3->X3_Valid       ,;
                     SX3->X3_Usado       ,;
                     SX3->X3_Tipo        ,;
                     SX3->X3_Arquivo     ,;
                     SX3->X3_Context})
		
   EndIf
	
   SX3->(dbSkip())
	
End

/* Estrutura do aHeader:
Cada elemento do aHeader , por sua vez, um array contendo as
seguintes informacoes sobre cada campo que ir para a GetDados.
,--------,-------,---------,---------,---------,-------,-------,------,---------,---------,
|   1    |   2   |    3    |    4    |    5    |   6   |   7   |  8   |   9     |   10    |
| Titulo | Campo | Picture | Tamanho | Decimal | Valid | Usado | Tipo | Arquivo | Context |
'--------'-------'---------'---------'---------'-------'-------'------'---------'---------'
,=============================================================================================================================================================================================,
| ,-------------------------------------, ,-------------------------------------, ,-------------------------------------------, ,-----------------------------------------------------------, |
| |"Item","Z2_ITEM",,2,0,,,"C","SZ2","R"| |"Tipo","Z2_TIPO",,1,0,,,"C","SZ2","R"| |"Historico","Z2_HIST",,20,0,,,"C","SZ2","R"| |"Valor","Z2_VALOR","@E 999,999,999.99",12,2,,,"N","SZ2","R"| |
| '-------------------------------------' '-------------------------------------' '-------------------------------------------' '-----------------------------------------------------------' |
'============================================================================================================================================================================================='
*/

////////////////////////////////////////////////////////////////////////////////////////////////////
// Cria o vetor aCols: contem os dados dos campos da tabela.                                      //
// Cada linha de aCols  uma linha da GetDados e as colunas so as colunas da GetDados.           //
// Se a opcao for INCLUIR, cria o vetor aCols com as caracteristicas de cada campo.               //
// Caso contrario, atribui os dados ao vetor aCols.                                               //
////////////////////////////////////////////////////////////////////////////////////////////////////

If nOpc == 3            // A opcao selecionada  INCLUIR.

   /*         ,=============================================================,
     aHeader  |    1.elem.   2.elem.    3.elem.         4.elem.             |
              |  ,---------,---------,-----------,-------------------,      |
   Titulo   1 |  | Item    | Tipo    | Historico | Valor             |      |
   Campo    2 |  | Z2_ITEM | Z2_TIPO | Z2_HIST   | Z2_VALOR          |      |
   Picture  3 |  |         |         |           | @E 999,999,999.99 |      |
   Tamanho  4 |  | 2       | 1       | 20        | 12                |      |
   Decimal  5 |  | 0       | 0       | 0         | 2                 |      |
   Valid    6 |  |         |         |           |                   |      |
   Usado    7 |  |         |         |           |                   |      |
   Tipo     8 |  | C       | C       | C         | N                 |      |
   Arquivo  9 |  | SZ2     | SZ2     | SZ2       | SZ2               |      |
   Context 10 |  | R       | R       | R         | R                 |      |
              |  '---------'---------'-----------'-------------------'      |
              '============================================================='
              ,=============================================================,
              |    [1][1]    [1][2]     [1][3]          [1][4]       [1][5] |
              |  ,---------,---------,-----------,-------------------,---,  |
     aCols[1] |  |         |         |           |                   |   |  |
              |  '---------'---------'-----------'-------------------'---'  |
              '============================================================='*/

   // Como cada elemento de aCols sempre contera um elemento a mais que o aHeader,
   // adiciona em aCols um ARRAY com o "num.elementos de aHeader + 1", ou seja, 5 elementos.
   AAdd(aCols, Array(Len(aHeader)+1))  // aCols[1] --> { Nil, Nil, Nil, Nil, Nil }

   /* Preenche cada elemento desse array, de acordo com o Inicializador-Padrao do Dic.Dados.

   ,===(aCols)=======================================================================================================================================,
   |                                aCols[1]  (Na inclusao, so aCols[1])                                    aCols[2]                                 |
   |   ,---------------,---------------,---------------,---------------,---,   ,---------------,---------------,---------------,---------------,     |
   |   |           1   |           2   |           3   |           4   |   |   |           1   |           2   |           3   |           4   |     |
   |   |  aCols[1][i]  |  aCols[1][i]  |  aCols[1][i]  |  aCols[1][i]  |   |   |  aCols[2][i]  |  aCols[2][i]  |  aCols[2][i]  |  aCols[2][i]  | ... |
   |   '---------------'---------------'---------------'---------------'---'   '---------------'---------------'---------------'---------------'     |
   '================================================================================================================================================='
   ,===(aHeader)=============================================================,
   |             1               2               3               4           |
   |     aHeader[i][2]   aHeader[i][2]   aHeader[i][2]   aHeader[i][2]       |
   |                |               |               |               |        |
   |   ,------------|--,------------|--,------------|--,------------|--,     |
   |   | Item       |  | Tipo       |  | Historico  |  | Valor      |  |     |
   |   | Z2_ITEM <--'  | Z2_TIPO <--'  | Z2_HIST <--'  | Z2_VALOR <-'  |     |
   |   '---------------'---------------'---------------'---------------'     |
   '========================================================================='*/

   For nCol := 1 To Len(aHeader)
       aCols[1][nCol] := CriaVar(aHeader[nCol][2])
   Next
   //  Equivale a: aCols[1][1] := CriaVar("Z2_ITEM" )
   //              aCols[1][2] := CriaVar("Z2_TIPO" )
   //              aCols[1][3] := CriaVar("Z2_HIST" )
   //              aCols[1][4] := CriaVar("Z2_VALOR")

   // Inicializa a ultima coluna com .F. indicando que a linha no est deletada.
   // aCols[1][5] := .F.
   aCols[1][Len(aHeader)+1] := .F.

   // Inicializa a coluna do ITEM com 01.
   // aCols[1][1] := "01"  <-- teria problema se o usuario alterasse a posicao do
   //                          campo Z2_ITEM no Dic. de Dados. 
   aCols[1][AScan(aHeader, {|aX|Trim(aX[2])=="Z2_ITEM"})] := "01"

 Else                   // Opcao ALTERAR ou EXCLUIR.

   M->Z2_Numero := SZ2->Z2_Numero
   M->Z2_Nome   := SZ2->Z2_Nome
   M->Z2_Data   := SZ2->Z2_Data

   dbSelectArea(cAlias)
   dbOrderNickName("NOME_NR_IT")  // Z2_Filial + Z2_Nome + Z2_Numero + Z2_Item
   dbSeek(xFilial(cAlias) + M->Z2_Nome + M->Z2_Numero)

   While !EOF() .And. SZ2->(Z2_Filial+Z2_Numero) == xFilial(cAlias) + M->Z2_Numero

   /*         ,==================================================================,
     aHeader  |    1.elem.   2.elem.    3.elem.         4.elem.                  |
              |  ,---------,---------,-----------,-------------------,           |
   Titulo   1 |  | Item    | Tipo    | Historico | Valor             |           |
   Campo    2 |  | Z2_ITEM | Z2_TIPO | Z2_HIST   | Z2_VALOR          |           |
   ...        /  /         /         /           /                   /           /
   Context 10 |  | R       | R       | R         | R                 |           |
              |  '---------'---------'-----------'-------------------'           |
              '=================================================================='     aAlt
              ,==================================================================,   ,-------,
              |  ,---------,---------,-----------,-------------------,--------,  |   |       |
     aCols[1] |  | [1][1]  | [1][2]  |  [1][3]   |      [1][4]       | [1][5] |  |   |Recno()| aAlt[1]
              |  '---------'---------'-----------'-------------------'--------'  |   |-------|
              |  ,---------,---------,-----------,-------------------,--------,  |   |       |
     aCols[2] |  | [2][1]  | [2][2]  |  [2][3]   |      [2][4]       | [2][5] |  |   |Recno()| aAlt[2]
              |  '---------'---------'-----------'-------------------'--------'  |   |-------|
              |  ,---------,---------,-----------,-------------------,--------,  |   |       |
     aCols[3] |  | [3][1]  | [3][2]  |  [3][3]   |      [3][4]       | [3][5] |  |   |Recno()| aAlt[3]
              |  '---------'---------'-----------'-------------------'--------'  |   '-------'
              '=================================================================='*/

      // Como cada elemento de aCols sempre contera um elemento a mais que o aHeader,
      // adiciona em aCols um ARRAY com o "num.elementos de aHeader + 1", ou seja, 5 elementos.
      AAdd(aCols, Array(Len(aHeader)+1))  // aCols[1] --> { Nil, Nil, Nil, Nil, Nil }

      nLin := Len(aCols)                  // Nr. da linha que foi criada.

      // Preenche a linha que foi criada com os dados contidos na tabela.
      For nCol := 1 To Len(aHeader)
          If aHeader[nCol][10] == "R"                                   // Campo  real.
             aCols[nLin][nCol] := FieldGet(FieldPos(aHeader[nCol][2]))  // Carrega o conteudo do campo.
           Else
             // A funcao CriaVar() le as definicoes do campo no dic.dados e carrega a variavel de acordo com
             // o Inicializador-Padrao, que, se nao foi definido, assume conteudo vazio.
             aCols[nLin][nCol] := CriaVar(aHeader[nCol][2], .T.)
          EndIf
      Next

      // Inicializa a ultima coluna para o controle da GetDados: deletado ou nao.
      aCols[nLin][Len(aHeader)+1] := .F.

      // Guarda o numero dos registros para controle da gravacao.
      AAdd(aAlt, Recno())

      dbSelectArea(cAlias)
      dbSkip()

   End

EndIf

////////////////////////////////////////////////////////////////////////////////////////////////////
// Define a janela que conter o Enchoice e a GetDados.                                           //
////////////////////////////////////////////////////////////////////////////////////////////////////

Define Font oFont Name "Courier" Size 8,14 Bold

Define MSDialog oDlg Title "Transaes Modelo 2" From 0,0 To 0,0 Pixel
oDlg:lMaximized := .T.

/*
MsMGet(<cAlias>, [nReg], <nOpc>, [aCRA], [cLetra], [cTexto], [aAcho], [aPos], [aCpos], [nModelo], [nColMens], [cMensagem], [cTudoOk], [oWnd], [lF3], [lMemoria], [lColumn], [caTela], [lNoFolder], [lProperty]) --> Nil

Parmetros Argumento Tipo Descrio
 
cAlias     Caracter  Tabela cadastrada no Dicionrio de Tabelas (SX2) que ser editada.
nReg       (NULO)    Parametro no utilizado.
nOpc       Numrico  Nmero da linha do aRotina que definir o tipo de edio (Incluso, Alterao, Excluso, Visualizao).
aCRA       (NULO)    Parametro no utilizado.
cLetra     (NULO)    Parametro no utilizado.
cTexto     (NULO)    Parametro no utilizado.
aCampos    Array     Vetor com nome dos campos que sero exibidos.
                     Os campos de usurio sempre sero exibidos se no existir no parametro um elemento com a expresso "NOUSER".
aPosicao   Array     Vetor com coordenadas para criao da Enchoice no formato {<top>, <left>, <bottom>, <right>}.
aEdit      Array     Vetor com nome dos campos que podero ser editados.
nModelo    Numrico  Se for diferente de 1 desabilita execuo de gatilhos estrangeiros.
nColMens   (NULO)    Parametro no utilizado.
cMensagem  (NULO)    Parametro no utilizado.
cTudoOk    (NULO)    Parametro no utilizado.
oWnd       Objeto    Objeto (janela, painel, etc) onde a enchoice ser criada.
lF3        Lgico    Indica se a enchoice esta sendo criada em uma consulta F3 para utilizar variveis de memria.
lMemoria   Lgico    Indica se a enchoice utilizar variveis de memria ou os campos da tabela na edio.
lColuna    Lgico    .F. --> os campos serao distribuidos em duas colunas.
                     .T. --> os campos ficarao numa nica coluna.
caTela     Caracter  Nome da varivel tipo "private" que a enchoice utilizar no lugar da propriedade aTela.
lNoFolder  Lgico    Indica se a enchoice no ir utilizar as Pastas de Cadastro (SXA).
lProperty  Lgico    Indica se a enchoice no utilizar as variveis aTela e aGets, somente suas propriedades com os mesmos nomes.
*/

aCampos  := {"NOUSER","Z2_NUMERO","Z2_NOME","Z2_DATA"}
aPosicao := {18, 5, 50, oDlg:oWnd:nClientWidth/2-10}
aEdit    := If(nOpc == 3, {"Z2_NOME","Z2_DATA"}, {})
lColuna  := .F.

dbSelectArea(cAlias)
dbGoTo(nReg)
oEnchoice := MsMGet():New(cAlias, , nOpc, , , , aCampos, aPosicao, aEdit, , , , , oDlg, , , lColuna)

/*
MsGetDados():New( nTop, nLeft, nBottom, nRight, nOpc, [cLinhaOk], [cTudoOk], [cIniCpos], [lDelete], [aAlter], [uPar1], [lEmpty], [nMax], [cFieldOk], [cSuperDel], [uPar2], [cDelOk], [oWnd])

Argumentos  Descrio 

nTop        Distancia entre a MsGetDados e o extremidade superior do objeto que a contm.
nLeft       Distancia entre a MsGetDados e o extremidade esquerda do objeto que a contm.
nBottom     Distancia entre a MsGetDados e o extremidade inferior do objeto que a contm.
nRight      Distancia entre a MsGetDados e o extremidade direita do objeto que a contm.
nOpc        Posio do elemento do vetor aRotina que a MsGetDados usar como referencia.
cLinhaOk    Funo para validar o contexto da linha atual do aCols (executada na mudana de linha).
cTudoOk     Funo para validar o contexto geral da MsGetDados - todo aCols (executada no boto OK).
cIniCpos    Nome dos campos do tipo caracter que utilizaro incremento automtico.
            Este parametro deve ser no formato +<nome do primeiro campo>+<nome do segundo campo>+....
lDelete     Habilita deletar linhas do aCols. Valor padrao falso.
aAlter      Vetor com os campos que podero ser alterados.
uPar1       Parametro reservado.
lEmpty      Habilita validao da primeira coluna do aCols para esta no poder estar vazia. Valor padro falso.
nMax        Nmero mximo de linhas permitidas. Valor padro 99.
cFieldOk    Funo executada na validao do campo.
cSuperDel   Funo executada quando pressionada as teclas <Ctrl>+<Delete>.
uPar2       Parmetro reservado.
cDelOk      Funo executada para validar a excluso de uma linha do aCols.
oWnd        Objeto no qual a MsGetDados ser criada.
*/

nTop      := oEnchoice:oBox:nBottom/2 + 5
nLeft     := oEnchoice:oBox:nLeft/2
nBottom   := oDlg:oWnd:nHeight/2 - 80
nRight    := oEnchoice:oBox:nRight/2
cLinhaOK  := "u_TM2LinOK()"
cTudoOK   := "u_TM2TudOK()"
cIniCpos  := "+Z2_ITEM"
lDelete   := .T.
nMax      := 99
cFieldOK  := "u_TM2FldOK()"
cSuperDel := "(MsgInfo('SuperDel'), .T.)"
cDelOK    := "u_TM2DelOK()"

oGetDados := MsGetDados():New(nTop, nLeft, nBottom, nRight, nOpc, cLinhaOK, cTudoOK, cIniCpos, lDelete, , , , nMax, cFieldOK, cSuperDel, , cDelOK, oDlg)

@oGetDados:oBrowse:nBottom/2+10,oGetDados:oBrowse:nRight/2-160 Say oSayTotalD Var "Total de depsitos:" Size 300,15 Pixel Font oFont Of oDlg
@oGetDados:oBrowse:nBottom/2+20,oGetDados:oBrowse:nRight/2-160 Say oSayTotalS Var "Total de saques...:" Size 300,15 Pixel Font oFont Of oDlg

TM2Total(.F.)

Activate MSDialog oDlg Centered On Init EnchoiceBar(oDlg, {||TM2Grava(cAlias,nOpc,aAlt),oDlg:End()}, {||RollBackSX8(),oDlg:End()})

Return Nil

//----------------------------------------------------------------------------------------------------------------//
Static Function TM2Grava(cAlias, nOpc, aAlt)

If      nOpc == 3    // Inclusao
        If MsgYesNo("Confirma a gravacao dos dados?", "Incluso")
           // Cria um dialogo com uma regua de progressao.
           Processa({||TM2Inclu(cAlias)}, "Aguarde!", "Gravando os dados, aguarde...")
        EndIf
 ElseIf nOpc == 4    // Alteracao
        If MsgYesNo("Confirma a alteracao dos dados?", "Alterao")
           // Cria um dialogo com uma regua de progressao.
           Processa({||TM2Alter(cAlias, aAlt)}, "Aguarde!", "Alterando os dados, aguarde...")
        EndIf
 ElseIf nOpc == 5    // Exclusao
        If MsgYesNo("Confirma a exclusao dos dados?", "Excluso")
           // Cria um dialogo com uma regua de progressao.
           Processa({||TM2Exclu(cAlias)}, "Aguarde!", "Excluindo os dados, aguarde...")
        EndIf
EndIf

Return Nil

//----------------------------------------------------------------------------------------------------------------//
Static Function TM2Inclu(cAlias)

Local nLin
Local nCol
Local nNrCampo

ProcRegua(Len(aCols))

dbSelectArea(cAlias)
dbOrderNickName("NR_IT")

For nLin := 1 To Len(aCols)

    IncProc()

    If !aCols[nLin][Len(aHeader)+1]  // A linha nao esta deletada, logo, deve ser gravada.

       RecLock(cAlias, .T.)

       For nCol := 1 To Len(aHeader)
           nNrCampo := FieldPos(Trim(aHeader[nCol][2]))
           FieldPut(nNrCampo, aCols[nLin][nCol])
       Next

       SZ2->Z2_Filial := xFilial(cAlias)
       SZ2->Z2_Nome   := M->Z2_Nome
       SZ2->Z2_Numero := M->Z2_Numero
       SZ2->Z2_Data   := M->Z2_Data

       MSUnlock()

       // Atualiza saldo
       dbSelectArea("SZ1")
       dbOrderNickName("NOME")
       dbSeek(xFilial("SZ1")+SZ2->Z2_Nome)
       RecLock("SZ1", .F.)
       If SZ2->Z2_Tipo == "1"
          SZ1->Z1_Saldo := SZ1->Z1_Saldo + SZ2->Z2_Valor
       Else
          SZ1->Z1_Saldo := SZ1->Z1_Saldo - SZ2->Z2_Valor
       EndIf
       MSUnlock()

    EndIf

Next

ConfirmSX8()

Return Nil

//----------------------------------------------------------------------------------------------------------------//
Static Function TM2Alter(cAlias, aAlt)

Local nLin
Local nCol
Local nNrCampo

ProcRegua(Len(aCols))

dbSelectArea(cAlias)
dbOrderNickName("NR_IT")

For nLin := 1 To Len(aCols)
	
    If nLin <= Len(aAlt)
		
       // aAlt contem o Recno() dos registros originais.
       // O usuario pode ter incluido mais registros na GetDados (aCols).
		
       dbSelectArea("SZ2")
       dbGoTo(aAlt[nLin])  // Posiciona no registro.

       If aCols[nLin][Len(aHeader)+1]     // A linha esta deletada.

          // Desatualiza
          dbSelectArea("SZ1")
          dbSeek(xFilial("SZ1")+SZ2->Z2_Nome)
          RecLock("SZ1", .F.)
          If SZ2->Z2_Tipo == "1"
             SZ1->Z1_Saldo := SZ1->Z1_Saldo - SZ2->Z2_Valor
          Else
             SZ1->Z1_Saldo := SZ1->Z1_Saldo + SZ2->Z2_Valor
          EndIf
          MSUnlock()

          // E depois deleta o registro correspondente.
          RecLock(cAlias, .F.)
          SZ2->(dbDelete())

       Else                            // A linha nao esta deletada.

          // Desatualiza
          dbSelectArea("SZ1")
          dbSeek(xFilial("SZ1")+SZ2->Z2_Nome)
          RecLock("SZ1", .F.)
          If SZ2->Z2_Tipo == "1"
             SZ1->Z1_Saldo := SZ1->Z1_Saldo - SZ2->Z2_Valor
           Else
             SZ1->Z1_Saldo := SZ1->Z1_Saldo + SZ2->Z2_Valor
          EndIf
          MSUnlock()
              
          RecLock("SZ2", .F.)

          // Regrava os dados.
          For nCol := 1 To Len(aHeader)
              nNrCampo := FieldPos(Trim(aHeader[nCol][2]))
              FieldPut(nNrCampo, aCols[nLin][nCol])
          Next

          SZ2->(MSUnlock())

          // Atualiza
          dbSelectArea("SZ1")
          dbSeek(xFilial("SZ1")+SZ2->Z2_Nome)
          RecLock("SZ1", .F.)
          If SZ2->Z2_Tipo == "1"
             SZ1->Z1_Saldo := SZ1->Z1_Saldo + SZ2->Z2_Valor
           Else
             SZ1->Z1_Saldo := SZ1->Z1_Saldo - SZ2->Z2_Valor
          EndIf
          MSUnlock()

       EndIf

    Else     // Foram incluidas mais linhas na GetDados (aCols), logo, precisam ser incluidas.

       If !aCols[nLin][Len(aHeader)+1]

          RecLock(cAlias, .T.)

          For nCol := 1 To Len(aHeader)
              nNrCampo := FieldPos(Trim(aHeader[nCol][2]))
              FieldPut(nNrCampo, aCols[nLin][nCol])
          Next

          SZ2->Z2_Filial := xFilial(cAlias)
          SZ2->Z2_Nome   := M->Z2_Nome
          SZ2->Z2_Numero := M->Z2_Numero
          SZ2->Z2_Data   := M->Z2_Data

          MSUnlock()

          // Atualiza saldo

          dbSelectArea("SZ1")
          dbOrderNickName("NOME")
          dbSeek(xFilial("SZ1")+SZ2->Z2_Nome)
          RecLock("SZ1", .F.)
          If SZ2->Z2_Tipo == "1"
             SZ1->Z1_Saldo := SZ1->Z1_Saldo + SZ2->Z2_Valor
          Else
             SZ1->Z1_Saldo := SZ1->Z1_Saldo - SZ2->Z2_Valor
          EndIf
          MSUnlock()

       EndIf

    EndIf

Next

Return Nil

//----------------------------------------------------------------------------------------------------------------//
Static Function TM2Exclu(cAlias)

ProcRegua(Len(aCols))

dbSelectArea(cAlias)
dbOrderNickName("NOME_NR_IT")
dbSeek(xFilial(cAlias) + M->Z2_Nome + M->Z2_Numero)

While !Eof() .And. SZ2->Z2_Filial == xFilial(cAlias) .And. SZ2->Z2_Numero == M->Z2_Numero

   // Nao precisa testar o nome pois numero e' chave primria.

   IncProc()

   // Desatualiza
   dbSelectArea("SZ1")
   dbSeek(xFilial()+SZ2->Z2_Nome)
   RecLock("SZ1", .F.)
   If SZ2->Z2_Tipo == "1"
      SZ1->Z1_Saldo := SZ1->Z1_Saldo - SZ2->Z2_Valor
   Else
      SZ1->Z1_Saldo := SZ1->Z1_Saldo + SZ2->Z2_Valor
   EndIf
   MSUnlock()

   RecLock(cAlias, .F.)
   dbDelete()
   MSUnlock()

   dbSelectArea("SZ2")
   dbSkip()

End

Return Nil

//----------------------------------------------------------------------------------------------------------------//
// Validao de excluso de linha (ao deletar uma linha na GetDados).
// A funo  executada duas vezes:
//   1 - Na prpria excluso da linha;
//   2 - No refresh do objeto. Nesta segunda execuo, no deve passar pela rotina de validao.
//----------------------------------------------------------------------------------------------------------------//
User Function TM2DelOK()

Local lRet := .T.
Static lPrimeiraVez := .T.

If lPrimeiraVez
   If !aCols[n][Len(aHeader)+1]
      lRet := MsgYesNo("Confirma a excluso da linha?")
   EndIf
   lPrimeiraVez := .F.
 Else
   lPrimeiraVez := .T.
EndIf   

TM2Total(.F.)

Return lRet

//----------------------------------------------------------------------------------------------------------------//
// Validao de campo.
// Sequencia de execues aps o <Enter> no campo:
//   1 - validao definida no SX3;
//   2 - esta validao;
//   3 - gatilhos.
//----------------------------------------------------------------------------------------------------------------//
User Function TM2FldOK()

If ReadVar() == "M->Z2_VALOR"
   TM2Total(.T.)
EndIf

Return .T.

//----------------------------------------------------------------------------------------------------------------//
// Atualiza os totais.
//----------------------------------------------------------------------------------------------------------------//
Static Function TM2Total(lMem)

Local nTotalDep := 0
Local nTotalSaq := 0
Local nColTipo
Local nColValor
Local nLin
Local nValor

nColTipo  := AScan(aHeader, {|aX| Trim(aX[2])=="Z2_TIPO"})           // Nr. da coluna do Tipo.
nColValor := AScan(aHeader, {|aX| Trim(aX[2])=="Z2_VALOR"})          // Nr. da coluna do Valor.

For nLin := 1 To Len(aCols)

    If !aCols[nLin][Len(aHeader)+1]                                  // Verifica se a linha no est deletada.

       // A varivel "n" contm o numero da linha atual da GetDados.
       // Se for a linha atual e o campo de valor estiver sendo editado,
       // deve obter o valor da memria pois ainda no foi atualizado no aCols.
       If nLin == n
          nValor := If(lMem, M->Z2_VALOR, aCols[nLin][nColValor])
        Else
          nValor := aCols[nLin][nColValor]
       EndIf

       If aCols[nLin][nColTipo] == "1"
          nTotalDep += nValor
        Else
          nTotalSaq += nValor
       EndIf

    EndIf

Next

// Atualiza os campos na tela.
oSayTotalD:SetText("Total de depsitos: " + Transform(nTotalDep,"@E 999,999,999.99"))
oSayTotalD:Refresh()
oSayTotalS:SetText("Total de saques...: " + Transform(nTotalSaq,"@E 999,999,999.99"))
oSayTotalS:Refresh()

Return Nil

//----------------------------------------------------------------------------------------------------------------//
// Valida todas as linhas da GetDados ao confirmar a gravaao.
//----------------------------------------------------------------------------------------------------------------//
User Function TM2TudOK()

Local lRet := .T.
Local i    := 0
Local nDel := 0

For i := 1 To Len(aCols)
    If aCols[i][Len(aHeader)+1]
       nDel++
    EndIf
Next

If nDel == Len(aCols)
   MsgInfo("Para excluir todos os itens, utilize a opo EXCLUIR", cTitulo)
   lRet := .F.
EndIf

Return lRet

//----------------------------------------------------------------------------------------------------------------//
// Valida a linha atual da GetDados ao teclar seta para baixo ou para cima para a mudana de linha.
//----------------------------------------------------------------------------------------------------------------//
User Function TM2LinOK()

// ***EXERCICIO*** Desenvolva uma rotina para nao aceitar valor acima do parametro MV_VRMAX.
// A propriedade oGetDados:oBrowse:nAt contem o numero da linha que est sendo editada.

Return .T.
